using System;
using System.Collections;
using System.ComponentModel;


namespace TestApp.BufReport_DataGrid
{
	/// <summary>
	/// Summary description for BufReportSettingsData.
	/// </summary>
	public class BufReportSettingsData
	{
		#region variables

		/// Meldungsstring
		public string m_strErrMsg_BufReport = "Ungltiger Wert: der Wert darf zwischen 0 und 100 liegen";

		private int m_nBuffCount = 10;

		private string[] m_strBuffSize = {""};
		private int[] m_nBuffSize = {0};

		private int[] m_nBuffSizeBase = {0};

		private string m_strBuffSizeAsOneStr = "";
		private int m_nMemoryRest = 0;

		bool m_bIsInputOk = false;


		#endregion


		#region CTOR

		public BufReportSettingsData(int nCountOfBuffers, int[] InitBufSizes)
		{
			//
			// TODO: Add constructor logic here
			//
			BuffCount = nCountOfBuffers;
			InitAll();

			BuffSizesBase = InitBufSizes;
		}

		#endregion


		#region Help Function

		/// <summary>
		/// Initialisieren alle Arrays usw.
		/// </summary>
		private void InitAll()
		{
			m_strBuffSize = new string [m_nBuffCount];
			m_nBuffSize = new int [m_nBuffCount];
			m_nBuffSizeBase = new int [m_nBuffCount];

			// TODO - prfen, ob notwendig ist !!!
			for (int i = 0; i < m_nBuffCount; i++)
			{
				m_strBuffSize[i] = "";
				m_nBuffSize[i] = 0;
				m_nBuffSizeBase[i] = 0;
			}
		}

		
		
		/// <summary>
		/// prfen, ob das eingegebenes Zeichen eine Zahl ist
		/// </summary>
		/// <param name="strVal"> was getestet wird</param>
		/// <returns></returns>
		public bool IsCharValid(ref string strVal)
		{
			bool bIsNumber = false;

			// zuerst prfen, ob etwas eingegeben wurde
			if (strVal == "") return bIsNumber;

			bIsNumber = Char.IsNumber(strVal, 0); 
			if (false == bIsNumber)
			{
//				char[] sTmp = strVal.ToCharArray(0, strVal.Length - 1);
				string strTmp = strVal.Remove(strVal.Length - 1, 1);
				strVal = strTmp;

			}

			return bIsNumber;
		}



		/// <summary>
		/// speichern den aktuellen Wert fr den Buffer[nIndex]
		/// </summary>
		/// <param name="nIndex"></param>
		/// <param name="strVal"></param>
		public void SaveCurValueForBuf(int nIndex, string strVal)
		{
			m_nBuffSize[nIndex] = Convert.ToInt32(strVal);
		}


		/// <summary>
		/// prft, ob die Eingabe im TextBox stimmt
		/// </summary>
		/// <param name="strCheckVal_in"></param>
		/// <returns></returns>
		public bool CheckInsertedValue(string strCheckVal_in, ref int nCheckVal_out)
		{
			// zu prfender Wert 
			int nCheckVal = Convert.ToInt32(strCheckVal_in);
			nCheckVal_out = nCheckVal;
			if (nCheckVal > 100 || nCheckVal < 0) 
			{
				return false;
			}

			return true;
		}


		/// <summary>
		/// berechnen die Summe von allen Ziffern, die bis jetzt eingegeben wurden
		/// </summary>
		/// <returns></returns>
		public int CalcRestOfMemory()
		{
			int nMemoryRest = 100;

			for (int i = 0; i < m_nBuffCount; i++)
			{
				nMemoryRest -= m_nBuffSize[i];
			}

			return m_nMemoryRest = nMemoryRest;
		}

		
		/// <summary>
		/// beim Verlassen vom Dialog prfen, ob alles in Ordnung ist
		/// </summary>
		/// <returns></returns>
		public bool CheckResults()
		{
			if (m_nMemoryRest >= 0 && m_nMemoryRest <= 100)
			{
				m_bIsInputOk = true;
			}
			else
			{
				m_bIsInputOk = false;
			}

			return m_bIsInputOk;
		}


		#endregion


		#region Get / Set

		public int BuffCount
		{
			get
			{
				return m_nBuffCount;
			}

			set 
			{ 
				m_nBuffCount = value; 
			}
		}


		public string BuffSizesAsOneStr
		{
			get
			{
				string strTmp = "";

				// holen den aktuellen Wert aus jedem TextBox
				for (int i = 0; i < m_nBuffCount; i++)
				{
					string strVal = "";

					if (m_bIsInputOk == true)
						strVal = Convert.ToString(m_nBuffSize[i]);
					else
						strVal = Convert.ToString(m_nBuffSizeBase[i]);

					strTmp += " : ";
					strTmp += strVal;
				}

				m_strBuffSizeAsOneStr = strTmp;

				return m_strBuffSizeAsOneStr; 
			}
		}


		public int[] BuffSizesBase
		{
			set
			{
				for (int i = 0; i < m_nBuffCount; i++)
				{
					m_nBuffSizeBase[i] = (int)value[i];
					m_nBuffSize[i] = m_nBuffSizeBase[i];
				}
			}
		}


		#endregion
	}
}
