using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TestApp.BufReport_DataGrid
{
	/// <summary>
	/// Summary description for BufReportSettingsGrid.
	/// </summary>
	public class BufReportSettingsGrid : System.Windows.Forms.Form
	{

		#region mix

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#endregion


		#region variables

		#region Controls

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label m_lbl_Memory_Rest;

		private System.Windows.Forms.TextBox m_txtMemSize;

		private System.Windows.Forms.DataGrid m_dataGrid;

		private System.Windows.Forms.Button m_btnOK;
		private System.Windows.Forms.Button m_btnCancel;
		private System.Windows.Forms.Button m_btnHlp;
		
		#endregion

		#region String Constants

		private static string m_strColBufName = "Buffer";
		private static string m_strColBufNameMap = "BufNr";
		private static string m_strColMemVal = "Dedicated memory";
		private static string m_strColMemValMap = "MemVal";
		private static string m_strTabName = "BufRepGrid";

		#endregion

		#region other members

		private DataTable m_BufReportTable;
		private PropertyDescriptor[] m_pd;

		private BufReportSettingsData m_BufSizeData;

		private string m_strBuffSizeAsOneStr = "";
		private string[] m_strBuffNames;
		private int m_nMemoryRest = 0;

		private static bool m_bIsGridInit = false;

		#endregion

		#endregion


		#region Hauptfunktionen

		#region CTOR

		public BufReportSettingsGrid(int nCountOfBuffers, int[] InitBufSizes, string[] InitBufNames)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			// 1) speichern Namen von Buffers:
			// ===============================
			m_strBuffNames = new string[nCountOfBuffers]; 
			int nElemCountNames = InitBufNames.Length;
			int nElemCountVal = InitBufSizes.Length;
			int nMinCountInit = Math.Min( nElemCountNames, nElemCountVal);

			// suchen den kleineren Wert aus allen - nCountOfBuffers, nElemCountNames, nElemCountVal
			if (nCountOfBuffers > nMinCountInit)
			{
				nCountOfBuffers = nMinCountInit;
			}
			for (int i = 0; i < nCountOfBuffers; i++)
			{
				m_strBuffNames[i] = InitBufNames[i];
			}

			// 2) erzeugen unser Container - Objekt
			m_BufSizeData = new BufReportSettingsData(nCountOfBuffers, InitBufSizes);

			// 3) initialisieren Grid
			InitDataGrid(nCountOfBuffers, InitBufSizes, InitBufNames);

			m_bIsGridInit = true;
		}

		#endregion


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.m_dataGrid = new System.Windows.Forms.DataGrid();
			this.label1 = new System.Windows.Forms.Label();
			this.m_txtMemSize = new System.Windows.Forms.TextBox();
			this.m_lbl_Memory_Rest = new System.Windows.Forms.Label();
			this.m_btnOK = new System.Windows.Forms.Button();
			this.m_btnCancel = new System.Windows.Forms.Button();
			this.m_btnHlp = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.m_dataGrid)).BeginInit();
			this.SuspendLayout();
			// 
			// m_dataGrid
			// 
			this.m_dataGrid.AllowSorting = false;
			this.m_dataGrid.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.m_dataGrid.DataMember = "";
			this.m_dataGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.m_dataGrid.Location = new System.Drawing.Point(6, 12);
			this.m_dataGrid.Name = "m_dataGrid";
			this.m_dataGrid.PreferredColumnWidth = 140;
			this.m_dataGrid.Size = new System.Drawing.Size(402, 174);
			this.m_dataGrid.TabIndex = 4;
			this.m_dataGrid.Click += new System.EventHandler(this.m_dataGrid_Click);
			this.m_dataGrid.CurrentCellChanged += new System.EventHandler(this.m_dataGrid_CurrentCellChanged);
			// 
			// label1
			// 
			this.label1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.label1.Location = new System.Drawing.Point(6, 240);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(400, 2);
			this.label1.TabIndex = 10;
			this.label1.Text = "label1";
			// 
			// m_txtMemSize
			// 
			this.m_txtMemSize.AutoSize = false;
			this.m_txtMemSize.Location = new System.Drawing.Point(312, 198);
			this.m_txtMemSize.Name = "m_txtMemSize";
			this.m_txtMemSize.Size = new System.Drawing.Size(90, 24);
			this.m_txtMemSize.TabIndex = 23;
			this.m_txtMemSize.Text = "0";
			// 
			// m_lbl_Memory_Rest
			// 
			this.m_lbl_Memory_Rest.Location = new System.Drawing.Point(6, 198);
			this.m_lbl_Memory_Rest.Name = "m_lbl_Memory_Rest";
			this.m_lbl_Memory_Rest.Size = new System.Drawing.Size(200, 24);
			this.m_lbl_Memory_Rest.TabIndex = 22;
			this.m_lbl_Memory_Rest.Text = "Rest of memory volume   (in %):";
			// 
			// m_btnOK
			// 
			this.m_btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.m_btnOK.Location = new System.Drawing.Point(6, 252);
			this.m_btnOK.Name = "m_btnOK";
			this.m_btnOK.Size = new System.Drawing.Size(96, 24);
			this.m_btnOK.TabIndex = 11;
			this.m_btnOK.Text = "OK";
			this.m_btnOK.Click += new System.EventHandler(this.m_btnOK_Click);
			// 
			// m_btnCancel
			// 
			this.m_btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.m_btnCancel.Location = new System.Drawing.Point(204, 252);
			this.m_btnCancel.Name = "m_btnCancel";
			this.m_btnCancel.Size = new System.Drawing.Size(96, 24);
			this.m_btnCancel.TabIndex = 12;
			this.m_btnCancel.Text = "Cancel";
			// 
			// m_btnHlp
			// 
			this.m_btnHlp.Location = new System.Drawing.Point(312, 252);
			this.m_btnHlp.Name = "m_btnHlp";
			this.m_btnHlp.TabIndex = 24;
			this.m_btnHlp.Text = "Help";
			// 
			// BufReportSettingsGrid
			// 
			this.AcceptButton = this.m_btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.m_btnCancel;
			this.ClientSize = new System.Drawing.Size(412, 285);
			this.Controls.Add(this.m_btnHlp);
			this.Controls.Add(this.m_txtMemSize);
			this.Controls.Add(this.m_lbl_Memory_Rest);
			this.Controls.Add(this.m_btnCancel);
			this.Controls.Add(this.m_btnOK);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.m_dataGrid);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "BufReportSettingsGrid";
			this.Text = "Settings for buffered report";
			((System.ComponentModel.ISupportInitialize)(this.m_dataGrid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#endregion


		#region Handles

		#region Handles for Grid

		/// <summary>
		/// Reaktion auf jeden KLick
		/// </summary>
		/// <param name="msg"></param>
		/// <param name="keyData"></param>
		/// <returns></returns>
		protected override bool ProcessCmdKey(ref System.Windows.Forms.Message msg,
			System.Windows.Forms.Keys keyData)
		{
//			if( msg.WParam.ToInt32() >= (int) Keys.NumPad0 && msg.WParam.ToInt32() <= (int) Keys.NumPad9) return true;
			Console.Write(" \nProcess_CMD_KEY: ");

			string strVal = "";
			string strChar = "";

			bool bIsRowValid = false;
			strVal = GetCurCellValue(ref bIsRowValid);

			// wenn es um keine richtige Zeile geht:
			if (false == bIsRowValid)
			{
				strVal = "";
			}
			else
			{
				char sChar = (char)msg.WParam.ToInt32();
				strChar = Char.ToString(sChar);
			}
/*
			// prfen, ob es eine Ziffer ist
			bool bIsNumber = m_BufSizeData.IsCharValid(ref strChar);
			if (false == bIsNumber)
			{
				int nCellCol = m_dataGrid.CurrentCell.ColumnNumber;  
				int nCellRow = m_dataGrid.CurrentCell.RowNumber; 

				DataRow row = m_BufReportTable.Rows[nCellRow]; 

				row.BeginEdit(); 

				row[nCellCol] = strVal;

				Console.Write("\t Original \t" + row[nCellCol, DataRowVersion.Original]);
				Console.Write("\t Proposed \t" + row[nCellCol,DataRowVersion.Proposed] + "\n");

				m_BufReportTable.AcceptChanges(); 

				row.EndEdit(); 

				m_dataGrid.Refresh(); 

				return true;
			}		
*/
			return base.ProcessCmdKey(ref msg, keyData);
		}

		
		
		
		/// <summary>
		/// wenn eine neue Cell selektiert wird (= SetFocus)
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void m_dataGrid_CurrentCellChanged(object sender, System.EventArgs e)
		{
			Console.Write(" \nCURRENT_cell_changED: ");

			// Test - get a current value
			bool bIsRowValid = false;
			string strVal = GetCurCellValue(ref bIsRowValid);
		}
		
		
		
		/// <summary>
		/// jeder Click auf dem Grid (Spalten breiter machen oder so)
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void m_dataGrid_Click(object sender, System.EventArgs e)
		{
			bool bIsRowValid = false;
			string strVal = GetCurCellValue(ref bIsRowValid);
		}


		#endregion

		#region DataTable - Events ( Handles for processing of changes in cells )

		private static void Column_Changing( object sender, DataColumnChangeEventArgs e )
		{
			if (m_bIsGridInit == true)
			{
				Console.WriteLine( "\nCOLUMN_changING:  ColumnValue = {0} *** ColumnName={1} *** nochwas = {2} ", 
					e.Row[m_strColMemVal], e.Column.ColumnName, e.ProposedValue );
			}
		}
		protected static void OnColumnChanged(object sender, DataColumnChangeEventArgs args)
		{
			if (m_bIsGridInit == true)
			{
				Console.Write(" \nCOLUMN_changED: ");
				Console.Write(args.Column.ColumnName + " changed to '" + args.ProposedValue + "'\n");
			}
		}
		protected static void OnRowChanging(object sender, DataRowChangeEventArgs args)
		{
			if (m_bIsGridInit == true)
			{
				if (args.Action != DataRowAction.Nothing)
					Console.WriteLine("   \nROW_changING: Action = " + args.Action + ", ColumnValue = " + args.Row[m_strColMemVal]);
			}
		}

		protected static void OnRowChanged(object sender, DataRowChangeEventArgs args)
		{
			if (m_bIsGridInit == true)
			{
				if (args.Action != DataRowAction.Nothing)
					Console.WriteLine("\nROW_changED: Action = " + args.Action + ", ColumnValue = " + args.Row[m_strColMemVal]);

				// holen den aktuellen Wert
				int nVal = 0;
				bool bIsRowValid = false;
				//BufReportSettingsGrid
				string strVal = ((BufReportSettingsGrid)sender).GetCurCellValue(ref bIsRowValid);

				// prfen, ob der Wert < 100 ist
				bool bIsValid = ((BufReportSettingsGrid)sender).m_BufSizeData.CheckInsertedValue(strVal, ref nVal);
				if (bIsValid == false) 
				{
					MessageBox.Show(((BufReportSettingsGrid)sender).m_BufSizeData.m_strErrMsg_BufReport, "Fehler"); 

					//m_dataGrid.;  
					return;
				}

				// berechnen den alten Zustand vom MemoryRest
				int nCellRow = ((BufReportSettingsGrid)sender).m_dataGrid.CurrentCell.RowNumber; 
				((BufReportSettingsGrid)sender).m_BufSizeData.SaveCurValueForBuf(nCellRow, strVal);
				((BufReportSettingsGrid)sender).m_nMemoryRest = ((BufReportSettingsGrid)sender).m_BufSizeData.CalcRestOfMemory();
				if (((BufReportSettingsGrid)sender).m_nMemoryRest < 0)
				{
					//				m_txtMemSize.BackColor = Color.Red; 
				}
				else
				{
					//				m_txtMemSize.BackColor = Color.Black; 
				}
				string strMemRest = Convert.ToString(((BufReportSettingsGrid)sender).m_nMemoryRest);
				((BufReportSettingsGrid)sender).m_txtMemSize.Text = strMemRest;
				((BufReportSettingsGrid)sender).m_txtMemSize.Refresh(); 

			}
		}

		#endregion


		#region Handles for all elements excluding grid

		/// <summary>
		/// Reaktion auf OK - ButtonClick
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void m_btnOK_Click(object sender, System.EventArgs e)
		{
			bool bIsOk = m_BufSizeData.CheckResults();
			if (bIsOk == true)
			{
				base.DialogResult = DialogResult.OK;
			}
			else
			{
				base.DialogResult = DialogResult.None;
				MessageBox.Show("Passen Sie bitte alle Werte so, dass die Summe > 0 wird", "Fehler");
			}		
		}


		#endregion
		
		#endregion


		#region Help functions 


		private void InitDataGrid(int nCountOfBuffers, int[] InitBufSizes, string[] InitBufNames)
		{
			// clear all
			m_dataGrid.TableStyles.Clear();  

			// erzeugen die Tabelle mit Spalten (nur Struktur)
			SetGridDataSet();

			// fgen alle Spalten in GridColumnsCollection hinzu
			SetGridColStyles();

			// fllen den Grid mit Werten
			FillDataInGrid(nCountOfBuffers, InitBufSizes, InitBufNames);
		}


		/// <summary>
		/// fllen den Grid aus
		/// </summary>
		private void FillDataInGrid(int nCountOfBuffers, int[] InitBufSizes, 
									string[] InitBufNames)
		{
			for (int i = 0; i < nCountOfBuffers; i++)
			{
				DataRow dRow = m_BufReportTable.NewRow();

				dRow[m_strColBufName] = InitBufNames[i];
				dRow[m_strColMemVal] = InitBufSizes[i];
				m_BufReportTable.Rows.Add(dRow);
			}
			m_BufReportTable.AcceptChanges();

			m_nMemoryRest = m_BufSizeData.CalcRestOfMemory();
			string strMemRest = Convert.ToString(m_nMemoryRest);
			m_txtMemSize.Text = strMemRest;
			m_txtMemSize.Refresh(); 
		}

		
		
		/// <summary>
		/// setzen DataSet - Table with columns 
		/// </summary>
		private void SetGridDataSet()
		{
			m_pd = new PropertyDescriptor[2];

			m_BufReportTable = new DataTable(m_strTabName);
 
			// Add a new DataColumn to the DataTable. - "BufNr"
			DataColumn myColumn = new DataColumn(m_strColBufName);
			myColumn.DataType = System.Type.GetType("System.String");
			myColumn.DefaultValue = "";
			myColumn.ReadOnly = true;
			m_BufReportTable.Columns.Add(myColumn);

			// Get the CurrencyManager for the DataTable.
			CurrencyManager cm = (CurrencyManager)this.BindingContext[m_BufReportTable];
			// Use the CurrencyManager to get the PropertyDescriptor for the new column.
			m_pd[0] = cm.GetItemProperties()[m_strColBufName];

			// Spalte "MemVal"
			DataColumn myColumn1 = new DataColumn(m_strColMemVal);
			myColumn1.DataType = System.Type.GetType("System.String");
			myColumn1.DefaultValue = "";
			m_BufReportTable.Columns.Add(myColumn1);
			// Use the CurrencyManager to get the PropertyDescriptor for the new column.
			m_pd[1] = cm.GetItemProperties()[m_strColMemVal];

			m_dataGrid.DataSource = m_BufReportTable;

		}

		
		
		/// <summary>
		/// fgen alle Spalten in GridColumnsCollection hinzu
		/// </summary>
		private void SetGridColStyles()
		{
			/*
				When programmatically specifying column styles, always create 
				DataGridColumnStyle objects and add them to the 
				GridColumnStylesCollection object before adding 
				DataGridTableStyle objects to the GridTableStylesCollection object. 
				
				When you add an empty DataGridTableStyle object to the collection, 
				DataGridColumnStyle objects are automatically generated for you. 
				Consequently, an exception will be thrown if you try to add new 
				DataGridColumnStyle objects with duplicate MappingName values to 
				the GridColumnStylesCollection object.

			 */ 

			// Create the DataGridTextBoxColumn with the PropertyDescriptor.
			DataGridTextBoxColumn myColumnTextColumn = new DataGridTextBoxColumn(m_pd[0]);

			// Add the new DataGridColumn to the GridColumnsCollection.
			m_dataGrid.TableStyles.Add(new DataGridTableStyle());
			m_dataGrid.TableStyles[0].GridColumnStyles.Add(myColumnTextColumn);

			// Spalte "MemVal"
			myColumnTextColumn = new DataGridTextBoxColumn(m_pd[1]);
			m_dataGrid.TableStyles[0].GridColumnStyles.Add(myColumnTextColumn);

			// add a ColumnChanging event handler for the table.
			m_BufReportTable.ColumnChanging += new DataColumnChangeEventHandler( Column_Changing );
			m_BufReportTable.ColumnChanged  += new DataColumnChangeEventHandler(OnColumnChanged);
			m_BufReportTable.RowChanged     += new DataRowChangeEventHandler(OnRowChanged);
			m_BufReportTable.RowChanging    += new DataRowChangeEventHandler(OnRowChanging);
		}



		/// <summary>
		/// holen den Wert aus den aktuellen Cell
		/// </summary>
		/// <returns></returns>
		public string GetCurCellValue(ref bool bIsRowValid)
		{
			bIsRowValid = true;

			m_dataGrid.Refresh(); 

			// holen aktuelle Row und Column
			int nCellCol = m_dataGrid.CurrentCell.ColumnNumber;  
			int nCellRow = m_dataGrid.CurrentCell.RowNumber; 

			// prfen, ob die Zeile aktuell ist (besitzt Daten)
			if (nCellRow > m_BufSizeData.BuffCount - 1) 
			{
				bIsRowValid = false;
				return "";
			}

			string strValRes = m_dataGrid[nCellRow, nCellCol].ToString();
			Console.WriteLine("\t\tstrValRes = {0} *** Row = {1} *** Col = {2}", 
					strValRes, nCellRow, nCellCol); 
			return strValRes;

		
			/// oder so:
			/// ========
			// aktualisieren unsere Tabelle, die mit dem Grid verbunden ist
			CurrencyManager cm = (CurrencyManager)this.BindingContext[m_BufReportTable];
			cm.Refresh();  

			// holen uns aktuelle Row
			DataRow dRow = m_BufReportTable.Rows[nCellRow]; 

			// holen aktuelle Info aus dem aktuellen Cell
			string strBufName = dRow[m_strColBufName].ToString(); 
			string strVal = dRow[m_strColMemVal].ToString();
			Console.WriteLine("\t\tstrValRes = {0} *** Row = {1} *** Col = {2}", 
				strVal, nCellRow, nCellCol); 
			return strVal;
		}



		#endregion



		#region Get / Set

		public string StrBuffSizeAsOneStr
		{
			get 
			{ 
				return m_strBuffSizeAsOneStr = m_BufSizeData.BuffSizesAsOneStr; 
			}
		}

		#endregion




	}
}


// 
// CurrencyManager - Konteiner, v kotorom nahodjatsja vse tablicy
// PropertyDescriptor - opisatel' dlja stolbcov
// DataTable - tablica, v kotoroj nah. vse dannye dlja grida

// DataColumn - stolbcy dlja tablicy (vozmozhnye tipy: DataGridBoolColumn i DataGridTextBoxColumn).
//				Posle sozdanija oni d.b. vneseny v GridColumnsCollection.

// DataRow - stroky dlja tablicy