using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace TestApp
{
	/// <summary>
	/// Summary description for ListView.
	/// </summary>
	public class ListView : System.Windows.Forms.Form
	{
		#region variables - controls

		// ListView
		public System.Windows.Forms.ListView m_lstView;
		private System.Windows.Forms.ColumnHeader colBufNr;
		private System.Windows.Forms.ColumnHeader colBufMemValue;

		// ListBox
		private System.Windows.Forms.ListBox m_lstBox;
		
		#endregion


		#region other variables and functions 

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#endregion


		#region Main functions

		#region CTOR

		public ListView()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			InitListView();
			InitListBox();
		}

		#endregion


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.m_lstView = new System.Windows.Forms.ListView();
			this.m_lstBox = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// m_lstView
			// 
			this.m_lstView.GridLines = true;
			this.m_lstView.Location = new System.Drawing.Point(18, 12);
			this.m_lstView.MultiSelect = false;
			this.m_lstView.Name = "m_lstView";
			this.m_lstView.Size = new System.Drawing.Size(264, 96);
			this.m_lstView.TabIndex = 0;
			// 
			// m_lstBox
			// 
			this.m_lstBox.ColumnWidth = 10;
			this.m_lstBox.Location = new System.Drawing.Point(18, 144);
			this.m_lstBox.MultiColumn = true;
			this.m_lstBox.Name = "m_lstBox";
			this.m_lstBox.Size = new System.Drawing.Size(264, 95);
			this.m_lstBox.TabIndex = 1;
			// 
			// ListView
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 375);
			this.Controls.Add(this.m_lstBox);
			this.Controls.Add(this.m_lstView);
			this.Name = "ListView";
			this.Text = "ListView";
			this.ResumeLayout(false);

		}
		#endregion

		#endregion


		#region help function

		/// <summary>
		/// fllen ListView
		/// </summary>
		private void InitListView()
		{
			this.colBufNr = new System.Windows.Forms.ColumnHeader();
			this.colBufMemValue = new System.Windows.Forms.ColumnHeader();

			m_lstView.Columns.AddRange( new System.Windows.Forms.ColumnHeader[]
											{colBufNr, colBufMemValue});    
			this.m_lstView.View = System.Windows.Forms.View.Details;
			this.m_lstView.Click += new System.EventHandler(this.lstView_Click);

			// colBufNr
			this.colBufNr.Text = "BufNr";
			this.colBufNr.Width = 200;
			// 
			// colBufMemValue
			// 
			this.colBufMemValue.Text = "Memory";
			this.colBufMemValue.Width = 300;

			// eine Zeile
			ListViewItem item = new ListViewItem(new string[]{"1", "10"});
			item.Tag = 0;
			m_lstView.Items.Add(item);

			/*
			 // oder:
			 
			 // 1) Headers:
			 // ==========
			 // Create column headers for the items and subitems
			listView1.Columns.Add("Artist",  -2, HorizontalAlignment.Left);
			listView1.Columns.Add("Born",    -2, HorizontalAlignment.Left);
			listView1.Columns.Add("Died",    -2, HorizontalAlignment.Left);
			listView1.Columns.Add("Country", -2, HorizontalAlignment.Left);

			// andere Mglichkeit:
			ColumnHeader cHeader:
			cHeader.Text = "Info";
			cHeader.Width = -2;
			cHeader.TextAlign = HorizontalAlignment.Left;
			ListView.Columns.Add(ColumnHeader cHeader);
			
			 // 1) items, subitems:
			 // ===================
			
			// Create item and three subitems
			ListViewItem item1 = new ListViewItem("Manet",2);
			item1.SubItems.Add("1832");
			item1.SubItems.Add("1883");
			item1.SubItems.Add("France");
			
			// Create item and subitems using a constructor only
			ListViewItem item2 = new ListViewItem (new string[] {"Monet","1840","1926","France"}, 3);
			
			// Create item and subitems with blue background color
			ListViewItem item3 = new ListViewItem (new string[] {"Cezanne","1839","1906","France"}, 1,
			Color.Empty, Color.LightBlue, null);
			
			// Add the items to the ListView
			listView1.Items.AddRange( new ListViewItem[]{item1,item2,item3,item4,item5});
			*/		
			
		}


		/// <summary>
		/// fllen ListBox
		/// </summary>
		private void InitListBox()
		{
			m_lstBox.Items.Add("1");
  
		}


		#endregion

		#region Handles

		private void lstView_Click(object sender, System.EventArgs e)
		{
			try
			{
				// selected item
				uint messageIndex = Convert.ToUInt32(m_lstView.SelectedItems[0].Tag);
				string strVal = m_lstView.SelectedItems[0].SubItems[1].Text;    

				int i = 5;
			}
			catch(Exception ex)
			{
				MessageBox.Show("error:  " + ex.Message);
			}
		}


		#endregion

	}
}
