using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using System.Text; 

namespace TestApp.Elements
{
	/// <summary>
	/// Summary description for StringOperations.
	/// </summary>
	public class frmStringOperations : System.Windows.Forms.Form
	{

		#region variablen

		private System.Windows.Forms.Button m_btnTests;
		private System.Windows.Forms.TextBox m_TxtBoxRes;
		private System.Windows.Forms.Button m_btnOK;
		private System.Windows.Forms.Button m_btnCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		#endregion


		#region MainFunc

		public frmStringOperations()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.m_btnOK = new System.Windows.Forms.Button();
			this.m_btnCancel = new System.Windows.Forms.Button();
			this.m_btnTests = new System.Windows.Forms.Button();
			this.m_TxtBoxRes = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// m_btnOK
			// 
			this.m_btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.m_btnOK.Location = new System.Drawing.Point(12, 120);
			this.m_btnOK.Name = "m_btnOK";
			this.m_btnOK.Size = new System.Drawing.Size(84, 24);
			this.m_btnOK.TabIndex = 0;
			this.m_btnOK.Text = "OK";
			this.m_btnOK.Click += new System.EventHandler(this.m_btnOK_Click);
			// 
			// m_btnCancel
			// 
			this.m_btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.m_btnCancel.Location = new System.Drawing.Point(192, 120);
			this.m_btnCancel.Name = "m_btnCancel";
			this.m_btnCancel.Size = new System.Drawing.Size(84, 24);
			this.m_btnCancel.TabIndex = 1;
			this.m_btnCancel.Text = "Cancel";
			// 
			// m_btnTests
			// 
			this.m_btnTests.Location = new System.Drawing.Point(12, 18);
			this.m_btnTests.Name = "m_btnTests";
			this.m_btnTests.Size = new System.Drawing.Size(84, 24);
			this.m_btnTests.TabIndex = 2;
			this.m_btnTests.Text = "Start tests";
			this.m_btnTests.Click += new System.EventHandler(this.m_btnTests_Click);
			// 
			// m_TxtBoxRes
			// 
			this.m_TxtBoxRes.AutoSize = false;
			this.m_TxtBoxRes.Location = new System.Drawing.Point(108, 18);
			this.m_TxtBoxRes.Multiline = true;
			this.m_TxtBoxRes.Name = "m_TxtBoxRes";
			this.m_TxtBoxRes.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.m_TxtBoxRes.Size = new System.Drawing.Size(168, 90);
			this.m_TxtBoxRes.TabIndex = 3;
			this.m_TxtBoxRes.Text = "";
			// 
			// frmStringOperations
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 153);
			this.Controls.Add(this.m_TxtBoxRes);
			this.Controls.Add(this.m_btnTests);
			this.Controls.Add(this.m_btnCancel);
			this.Controls.Add(this.m_btnOK);
			this.Name = "frmStringOperations";
			this.Text = "StringOperations";
			this.ResumeLayout(false);

		}
		#endregion

		#endregion


		#region Handles

		private void m_btnTests_Click(object sender, System.EventArgs e)
		{
			StringsTest();
			CharsTest();
			StringBuilderTest();
		}

		private void m_btnOK_Click(object sender, System.EventArgs e)
		{
			bool bIsOk = true;
			if (bIsOk == true)
			{
				base.DialogResult = DialogResult.OK;
			}
			else
			{
				base.DialogResult = DialogResult.None;
			}		
		}
		
		#endregion


		#region HelpFunc

		private void StringsTest()
		{
			string strTest = "hallo";

			// einfache OPerationen
			int nPos = strTest.IndexOf("a" , 0);
			string strRes = strTest.Remove(strTest.Length - 1, 1);
			char[] sArray = strTest.ToCharArray(0, 3); 
			m_TxtBoxRes.Text = strRes;

			// string array
			string[] myArray = new string [] {"irina", "misha", "sema"};
			string strOneString = string.Join("*", myArray); 
			m_TxtBoxRes.Text += "\r\n" + strOneString;

			// Formatierung
			double fVal = 10;
			strOneString = String.Format("der wert = {0}, der Sqrt = {1:0.00}", fVal, Math.Sqrt(fVal));  
			m_TxtBoxRes.Text += "\r\n" + strOneString;

			fVal = 0.5;
			strOneString = String.Format("der wert = {0}, der Sqrt = {1:#,#.00}", fVal, Math.Sqrt(fVal));  
			m_TxtBoxRes.Text += "\r\n" + strOneString;

			// Arrays / Auflistungen - System.Collections
			ArrayList arList = new ArrayList(100);
			arList.Add("irina"); 
			arList.Add("mischa"); 
			arList.Add("sema"); 
			foreach (string str in arList)
			{
				m_TxtBoxRes.Text += "\r\n" + str;
			}

			Hashtable htArray = new Hashtable(100);
			htArray.Add(1001, "obj 1"); 
			htArray.Add(1002, "obj 2"); 
			htArray.Add(1003, "obj 3"); 
			htArray.Add(1004, "obj 4"); 
			htArray[1005] = "konez";
			m_TxtBoxRes.Text += "\r\n" + htArray[1004];



		}


		private void CharsTest()
		{
		}


		private void StringBuilderTest()
		{
			StringBuilder str = new StringBuilder(255, 1256);
			str.Append("ein test - ");
			str.Insert(0, "das ist ");
			str.AppendFormat("heute ist {0}, der {1}", DateTime.Today.DayOfWeek.ToString(),
				                                       DateTime.Today.ToShortDateString()); 

			string strRes = str.ToString(); 
			m_TxtBoxRes.Text += "\r\n" + strRes;

		}		
		
		#endregion

	}
}
