using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace TestApp
{
	/// <summary>
	/// Summary description for MenuTest.
	/// </summary>
	public class MenuTest : System.Windows.Forms.Form
	{

		#region Menu variables

		/// <summary>
		///  Menu variables
		/// </summary>
		private MainMenu mainMenu;
		private MenuItem menuEdit, menuInsert;

		private ContextMenu popUpMenu;
		private MenuItem checkHello;
		private MenuItem checkHowAreYou;
		private MenuItem checkChao;
		private MenuItem checkCurrent;

		#endregion


		#region Mix

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#endregion


		#region Hauptfunktionen

		public MenuTest()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			// Add Menu
			// ********
			StartMenuTest();
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// MenuTest
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(310, 147);
			this.Name = "MenuTest";
			this.Text = "MenuTest";
			//this.Load += new System.EventHandler(this.MenuTest_Load);

		}
		#endregion


		#endregion



		#region Menu Test code
		/// <summary>
		/// Menu test
		/// </summary>

		private void StartMenuTest()
		{
			MainMenuTest();

			PopupMenuTest();
		}

		private void MainMenuTest()
		{
			mainMenu = new MainMenu();
			
			MenuItem TestMenu = mainMenu.MenuItems.Add("&TEST");

			TestMenu.MenuItems.Add( new MenuItem ( "&Test 1 - Clone Menu",   new EventHandler (Test1_clicked ), Shortcut.CtrlT));
			TestMenu.MenuItems.Add( new MenuItem ( "T&est 2 - Merge Menu",   new EventHandler (Test2_clicked ), Shortcut.CtrlE));
			TestMenu.MenuItems.Add( new MenuItem ( "Te&st 3 - Delete Menu",  new EventHandler (Test3_clicked ), Shortcut.CtrlS));
			TestMenu.MenuItems.Add( new MenuItem ( "Te&st 4 - Replace Menu", new EventHandler (Test4_clicked ), Shortcut.CtrlS));
			TestMenu.MenuItems.Add(new MenuItem("-"));
			TestMenu.MenuItems.Add( new MenuItem ( "E&xit", new EventHandler (Exit_clicked ), Shortcut.CtrlX));
			this.Menu = mainMenu;

			MenuItem About = mainMenu.MenuItems.Add("&About");
			About.MenuItems.Add(new MenuItem("&About"));
			this.Menu=mainMenu;

			// die Items existieren nicht als extra Spalte im Men, sondern nur als vorgefertigte Menpunkte 
			menuEdit = new MenuItem("&Edit");
			menuEdit.MenuItems.Add(new MenuItem("Copy"));
			menuEdit.MenuItems.Add(new MenuItem("Paste"));

			menuInsert=new MenuItem("&Insert");
			menuInsert.MenuItems.Add(new MenuItem("Insert Item"));
			menuInsert.MenuItems.Add(new MenuItem("Insert Field"));
		}

		private void PopupMenuTest()
		{
			popUpMenu =new ContextMenu();

			popUpMenu.MenuItems.Add("ContextMenu - Hello", new EventHandler(PopupHello_Clicked));
			popUpMenu.MenuItems.Add("ContextMenu - HowAreYou", new EventHandler(PopupHello_Clicked));
			popUpMenu.MenuItems.Add("ContextMenu - Chao", new EventHandler(PopupHello_Clicked));

			this.ContextMenu = popUpMenu;

			checkHello = this.ContextMenu.MenuItems[0]; 
			checkHowAreYou = this.ContextMenu.MenuItems[1];
			checkChao = this.ContextMenu.MenuItems[2];

			checkCurrent = checkHello;
			checkCurrent.Checked = true;

		}

		#region MainMenu Handles code
		/// <summary>
		/// Menu test
		/// </summary>
		
		private void Exit_clicked(object sender, EventArgs e)
		{
			this.Close();
		}

		private void Test1_clicked(object sender, EventArgs e)
		{
			// die Menpunkte, die vorher nur als MenuItem-Objekte erzeugt waren,
			// werden im Men angezeigt
			mainMenu.MenuItems.Add(menuInsert.CloneMenu());
			this.Menu = mainMenu;
		}

		private void Test2_clicked(object sender, EventArgs e)
		{
			// die 2 vorher vorbereitet Mengruppen werden in einen Menpunkt zusammengestellt
			menuEdit.MergeMenu(menuInsert.CloneMenu());
			mainMenu.MenuItems.Add(menuEdit);
			menuEdit.Text = "&Merged";
			this.Menu = mainMenu;
		}

		private void Test3_clicked(object sender, EventArgs e)
		{
			mainMenu.MenuItems.Remove( menuEdit);
		}

		private void Test4_clicked(object sender, EventArgs e)
		{
			// fr replace 
			int nCount = mainMenu.MenuItems.Count;
 
			// -2: 
			// - 1 - weil Index ab 0 gezhlt wird, 
			// - 1 - weil die allgemeneine Anzahl von Elementen < nCount sein soll
			mainMenu.MenuItems[nCount - 2].Index++;
		}

		#endregion

		#region PopupMenu Handles code
		/// <summary>
		/// Menu test
		/// </summary>
		
		private void PopupHello_Clicked(object sender, EventArgs e)
		{
			checkCurrent.Checked = false;
			MenuItem miClicked = (MenuItem)sender;
			string item = miClicked.Text;
			if (item == "ContextMenu - Hello")
			{
				checkCurrent = checkHello;
				MessageBox.Show("ContextMenu - Hello");
			}
			if (item == "ContextMenu - HowAreYou")
			{
				checkCurrent = checkHowAreYou;
				MessageBox.Show("ContextMenu - HowAreYou");
			}
			if (item == "ContextMenu - Chao")
			{
				checkCurrent = checkChao;
				MessageBox.Show("ContextMenu - Chao");
			}
			checkCurrent.Checked = true;
			Invalidate();

		}
		#endregion


		#endregion

	}
}
