using System;

using System.Drawing;
using System.Drawing.Design;
using System.Collections;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using System.Data;

using TestApp;


//UITypeEditor
// Ellipse-Schaltflche = ellipsis button  ("...") 

//  : GlobalizedObject - um die Mglichkeit zu haben, Eigenschaften-Namen als unsere 
//						 Strings und nicht als Variablen-Namen anzuzeigen

// TestApp.PropertyGrid_all - weil wir diese Dateien in ein Unterverzeichnis 
//							  PropertyGrid_all verschoben haben

namespace TestApp.PropertyGrid_all
{
	/// <summary>
	/// Summary description for AppSettings.
	/// </summary>
	
	
	[DefaultPropertyAttribute("Buffered Report")]
	public class AppSettings  : GlobalizedObject
	{

		#region Variables
		/// <summary>
		/// Variables
		/// </summary>
		
		private string m_strBufferedReport = "";

		private string m_strAnwendungsnummer;
		private string m_strKommunikationsprofil;
		private string m_strVLANID;
		private string m_strVLANPrioritaet;
		private string m_strMACAdresse;
		private string m_strGSEControlName;
		private string m_strGSEControlGOID;
		private string m_strDataSetName;
		private int m_nMinimaleUeberwachungszeit;
		private int m_nMaximaleUeberwachungszeit;

		#endregion

		#region Beschreibung von Einstellungen
		/// <summary>
		/// Beschreibung von Einstellungen:
		/// 
		/// DescriptionAttribute - der Hilfstext, der bei der Eigenschaft-Auswahl im 
		///							unteren Textbox erscheint (geht nur in dem Fall, wenn 
		///							diese Klasse nicht von der ICustomTypeDescriptor abgeleitet 
		///							ist. Wenn es der Fall ist, dann muss man im StringTable 
		///							alles ablegen)
		/// DisplayName - damit wird unseres String als PropertyName angezeigt (geht nur in dem Fall, wenn 
		///							diese Klasse nicht von der ICustomTypeDescriptor abgeleitet 
		///							ist. Gibt aber erst ab VS 2005)
		/// CategoryAttribute - Gruppenname 
		/// BrowsableAttribute - sagt, ob die Eigenschaft im Grid zu sehen ist oder die ausgeblendet ist
		/// ReadOnlyAttribute - sagt, ob die Eigenschaft editierbar ist oder nicht
		/// DefaultValueAttribute - setzt den Default-Wert
		/// DefaultPropertyAttribute - setzt die Standart-Eigenschaft, die sofort Fokus bekommt. Wird vor der Klassendefinition gesetzt.
		/// </summary>
		#endregion


		#region CTOR

		public AppSettings()
		{
			//
			// TODO: Add constructor logic here
			//
		}
		#endregion


		#region Get-Set for all Settings

		/// <summary>
		/// alle get-set methoden fr alle variablen + Einstellungen fr den Grid
		/// </summary>
		

		// ***************************** Infos *******************

		[CategoryAttribute("Infos"),
		 Editor(typeof(MyTypeEditor), 
		 typeof(UITypeEditor))]
		public string  H_BufReport
		{
			get { return m_strBufferedReport; }
			set { m_strBufferedReport = value; }
		}


		// ***************************** Parameters *******************

		/// <summary>AppId der Anwendung</summary>
		[CategoryAttribute("Parameters"),ReadOnlyAttribute(true), Browsable(true)]
		public string Anwendungsnummer
		{
			get
			{
				string displayedGSEAppId = "0";
				m_strAnwendungsnummer = displayedGSEAppId;

				return displayedGSEAppId;
			}
		}

		/// <summary>Applikationsprofil</summary>
		[CategoryAttribute("Parameters"), ReadOnlyAttribute(true), Browsable(true)]
		public string Kommunikationsprofil
		{
			get
			{
				m_strKommunikationsprofil = "Hohe Prioritt";
				return m_strKommunikationsprofil;
			}
		}

		/// <summary>MinTime</summary>
		[CategoryAttribute("Parameters"), ReadOnlyAttribute(true), Browsable(true)]
		public int MinimaleUeberwachungszeit
		{
			get
			{
				m_nMinimaleUeberwachungszeit = 0;
				return m_nMinimaleUeberwachungszeit;
			}
            
		}

		/// <summary>MaxTime</summary>
		[CategoryAttribute("Parameters"), ReadOnlyAttribute(true), Browsable(true)]
		public int MaximaleUeberwachungszeit
		{
			get
			{
				m_nMaximaleUeberwachungszeit = 0;
				return m_nMaximaleUeberwachungszeit;
			}
		}


		/// <summary>VLAN-ID</summary>
		[CategoryAttribute("Parameters"), ReadOnlyAttribute(true), Browsable(true)]
		public string VLANID
		{
			get
			{
				m_strVLANID = "0";
				return m_strVLANID;
			}
		}

		/// <summary>VLAN-Prioritt</summary>
		[CategoryAttribute("Parameters"), ReadOnlyAttribute(true), Browsable(true)]
		public string VLANPrioritaet
		{
			get
			{
				m_strVLANPrioritaet = "4";
				return m_strVLANPrioritaet;
			}
		}

		/// <summary>MAC-Adresse</summary>
		[CategoryAttribute("Parameters"), ReadOnlyAttribute(true), Browsable(true)]
		public string MACAdresse
		{
			get
			{
				m_strMACAdresse = "0";
				return m_strMACAdresse;
			}
		}

		/// <summary>GSE-Control Name</summary>
		[CategoryAttribute("Parameters"), ReadOnlyAttribute(true), Browsable(true)]
		public string GSEControlName
		{
			get
			{
				m_strGSEControlName = "Control_DataSet2";
				return m_strGSEControlName;
			}
		}

		/// <summary>GSE-Control GO ID</summary>
		[CategoryAttribute("Parameters"), ReadOnlyAttribute(true), Browsable(true)]
		public string GSEControlGOID
		{
			get
			{
				m_strGSEControlGOID = "1";
				return m_strGSEControlGOID;
			}
		}


		/// <summary>DataSet Name</summary>
		[CategoryAttribute("Parameters"), ReadOnlyAttribute(true), Browsable(true)]
		public string DataSetName
		{
			get
			{
				m_strDataSetName = "DataSet2";
				return m_strDataSetName;
			}
		}


		#endregion

	}
}
