using System;

using System.Drawing;
using System.Drawing.Design;
using System.Collections;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using System.Data;



namespace TestApp.PropertyGrid_all
{
	/// <summary>
	/// Summary description for MyTypeEditor.
	/// 
	/// Das ist unsere Editor-Klasse, die uns ermglicht, eine Eigenschaft mit "..." im Grid zu bekommen
	/// 1) Man muss berschreiben 2 Funktonen:
	/// - UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext); - hier wird Style gesetzt: DropDown oder Modal
	/// - object EditValue(ITypeDescriptorContext,IServiceProvider,object); - eigentliche Edit-Mglichkeit
	/// 2) Dann muss man eine Variable einfgen:
	/// - private IWindowsFormsEditorService edSvc = null;
	/// 3) in der Klasse, wo die Eigenschaften bearbeitet werden, muss man fr die Eigenschaft, 
	///		die mit der Edit-Klasse bearbeitet werden soll, folgendes setzen:
	/// 	-	Editor(typeof(MyTypeEditor), typeof(UITypeEditor))
	/// </summary>
	/// 

	public class MyTypeEditor : UITypeEditor
	{
		private IWindowsFormsEditorService edSvc = null;

		private TestApp.BufReport_DataGrid.frmBufReportSettings m_frmRepSettings;

		public MyTypeEditor()
		{
			//
			// TODO: Add constructor logic here
			//
			m_frmRepSettings = null;
		}

		public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context) 
		{
			return UITypeEditorEditStyle.Modal;			
		}


		public override object EditValue(ITypeDescriptorContext context, 
										 IServiceProvider		provider, 
										 object					value) 
		{
			if (context != null && context.Instance != null && provider != null) 
			{
				edSvc = (IWindowsFormsEditorService)provider.GetService( typeof(IWindowsFormsEditorService) );

				if (edSvc != null) 
				{
					int[] BufSizesStart = new int[10];
					for (int i = 0; i < 10; i++)
					{
						BufSizesStart[i] = 10;
					}
		
					m_frmRepSettings = new TestApp.BufReport_DataGrid.frmBufReportSettings(10, BufSizesStart);
					if (edSvc.ShowDialog(m_frmRepSettings) == DialogResult.OK)
					{
						value = m_frmRepSettings.StrBuffSizeAsOneStr;
					}

					return (object)m_frmRepSettings.StrBuffSizeAsOneStr;
				}
				else
				{
					return value;
				}
			}
			return (object)m_frmRepSettings.StrBuffSizeAsOneStr;
		}

	}
}
