
#region namespaces

using System;

using System.Drawing;
using System.Drawing.Design;
using System.Collections;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;
using System.Data;

#endregion


namespace TestApp.PropertyGrid_all
{
	/// <summary>
	/// Summary description for PropGridData.
	/// </summary>
	/// 

	[DefaultPropertyAttribute("SaveOnClose")]
	public class PropGridData  : GlobalizedObject
	{
		#region Variables
		/// <summary>
		/// Variables
		/// </summary>
		/// 

		public enum VersionType
		{
			[DescriptionAttribute ("Basis Version")]
			nBaseVersion,

			[DescriptionAttribute ("Aktuelle Version")]
			nCurVersion
		};		


		private bool saveOnClose = true;
		private string greetingText = "Willkommen bei Ihrer Anwendung!";
		private int itemsInMRU = 4;
		private int maxRepeatRate = 10;
		private bool settingsChanged = false;
		private VersionType appVersion;
		private string defaultFileName = "c:\\temp\\tmp.txt";

		private SpellingOptions spellCheckOptions = new SpellingOptions() ;
		private string m_strState = "";
		private string m_strBufRep = "";

		private Size windowSize = new Size(100,100);
		private Font windowFont = new Font("Arial", 8, FontStyle.Regular);
		private Color toolbarColor = SystemColors.Control;



		#endregion


		#region CTOR

		public PropGridData()
		{

			//
			// TODO: Add constructor logic here
			//
		}

		#endregion


		#region Get-Set for all Settings

		/// <summary>
		/// alle get-set methoden fr alle variablen + Einstellungen fr den Grid
		/// </summary>
		

		#region Default Property Attribute

		// ***************************** Default Property Attribute *******************

		[CategoryAttribute("Default Property Attribute"), 
		 DefaultValueAttribute(true)]
		public bool SaveOnClose
		{
			get { return saveOnClose; }
			set { saveOnClose = value;}
		}

		#endregion


		#region Windows speziefische Einstellungen

		// ***************************** Windows speziefische Einstellungen *******************

		[CategoryAttribute("Windows speziefische Einstellungen")]
		public Size WindowSize 
		{
			get { return windowSize; }
			set { windowSize = value;}
		}

		[CategoryAttribute("Windows speziefische Einstellungen")]
		public Font WindowFont 
		{
			get {return windowFont; }
			set { windowFont = value;}
		}

		[CategoryAttribute("Windows speziefische Einstellungen")]
		public Color ToolbarColor
		{
			get { return toolbarColor; }
			set { toolbarColor = value; }
		}

		#endregion


		#region Einfache Einstellungen

		// ***************************** Einfache Einstellungen *******************

		[CategoryAttribute("Einfache Einstellungen"),
		 ReadOnlyAttribute(true),
		 DefaultValueAttribute("Willkommen bei Ihrer Anwendung!")] 
		public string GreetingText
		{
			get { return greetingText; }
			set { greetingText = value; }
		}

		[CategoryAttribute("Einfache Einstellungen"),
		 DefaultValueAttribute(4)]
		public int ItemsInMRUList
		{
			get { return itemsInMRU; }
			set { itemsInMRU = value; }
		}

		[CategoryAttribute("Einfache Einstellungen"),
		 DescriptionAttribute("Die Frequenz (in Millisekunden), in der der Text wiederholt wird."),
		 DefaultValueAttribute(10)]
		public int MaxRepeatRate
		{
			get { return maxRepeatRate; }
			set { maxRepeatRate = value; }
		}

		[CategoryAttribute("Einfache Einstellungen")] 
		public string DefaultFileName
		{
			get { return defaultFileName; }
			set { defaultFileName = value; }
		}

		#endregion


		#region Benutzerdefinierte Einstellung 

		// ***************************** Benutzerdefinierte Einstellung *******************

		[CategoryAttribute("Benutzerdefinierte Einstellung - TypeConverter")]	// Optionen fr die Rechtsschreibung
		public SpellingOptions SpellCheckOptions
		{
			get { return spellCheckOptions; }
			set { spellCheckOptions = value; }
		}


		[CategoryAttribute("Benutzerdefinierte Einstellung - TypeEditor")
		 , Editor(typeof(MyTypeEditor), typeof(UITypeEditor))
		]
		public string  H_BufReport
		{
			get { return m_strBufRep; }
			set { m_strBufRep = value; }
		}

		[CategoryAttribute("Benutzerdefinierte Einstellung - StringConverter"),
		TypeConverterAttribute(typeof(ComboBoxProperty)),
		DefaultValueAttribute("")]
		public string  State
		{
			get { return m_strState; }
			set { m_strState = value; }
		}


		[CategoryAttribute("Benutzerdefinierte Einstellung - Version"),
		DefaultValueAttribute(""),
		TypeConverterAttribute(typeof(EnumProperty))] 
		public VersionType AppVersion
		{
			get { return appVersion; }
			set { appVersion = value; }
		}

		#endregion

/*
		[BrowsableAttribute(false),
		DefaultValueAttribute(false)]
		public bool SettingsChanged
		{
			get { return settingsChanged; }
			set { settingsChanged = value; }
		}
*/
		#endregion

	}
}
