using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using System.Reflection; 
using System.Diagnostics;


namespace TestApp.PropertyGrid_all
{

	#region Zustzliche Klassen - Beschreibung
	/// <summary>
	/// Zustzliche Klassen fr den Grid:
	/// ==================================
	/// 
	/// - MyTypeEditor : UITypeEditor - ein Editor, um fr eine Eigenschaft einen 
	///					EinstellungsDialog (ber ...-Button) aufrufen zu knnen
	///					
	///	- SpellingOptions - eine Klasse fr eine benutzerdef. Eigenschaft
	///	- SpellingOptionsConverter : ExpandableObjectConverter - eine Converter-Klasse dafr
	///	
	/// </summary>
	#endregion

	/// <summary>
	/// Summary description for PropertyGrid.
	/// </summary>
	public class PropertyGrid : System.Windows.Forms.Form
	{
		#region Controls variables

		private System.Windows.Forms.Button m_btnTest;
		private System.Windows.Forms.TextBox m_txtRes;

		private System.Windows.Forms.PropertyGrid m_propertyGridEigenschaften;

		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;

		private System.Windows.Forms.Button m_btnSysConData;
		private System.Windows.Forms.Button m_btnExampleData;
		private System.Windows.Forms.Button m_btnExampleData2;

		private string m_strBufRep = ": 10 : 10 : ... : 10";

		#endregion


		#region Mix
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#endregion


		#region Hauptfunktionen
		/// <summary>
		/// Hauptfunktionen - CTOR, Main, InitializeComponent()
		/// </summary>
		/// 

		public PropertyGrid()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			// initialisieren den Grid
			this.m_propertyGridEigenschaften = new System.Windows.Forms.PropertyGrid();
			this.m_propertyGridEigenschaften.CommandsVisibleIfAvailable = true;
			this.m_propertyGridEigenschaften.Location = new Point(10, 20);
			this.m_propertyGridEigenschaften.Size = new System.Drawing.Size(600, 350);
			this.m_propertyGridEigenschaften.TabIndex = 1;
			this.m_propertyGridEigenschaften.Text = "Property Grid";
			this.m_propertyGridEigenschaften.PropertyValueChanged += new System.Windows.Forms.PropertyValueChangedEventHandler(this.propertyGrid1_PropertyValueChanged);

			this.Controls.Add(this.m_propertyGridEigenschaften);

			InitGridWithSysConData();
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		/// 

		private void InitializeComponent()
		{
			this.m_btnTest = new System.Windows.Forms.Button();
			this.m_txtRes = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.m_btnExampleData2 = new System.Windows.Forms.Button();
			this.m_btnExampleData = new System.Windows.Forms.Button();
			this.m_btnSysConData = new System.Windows.Forms.Button();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();

			// 
			// m_btnTest
			// 
			this.m_btnTest.Location = new System.Drawing.Point(18, 24);
			this.m_btnTest.Name = "m_btnTest";
			this.m_btnTest.Size = new System.Drawing.Size(60, 24);
			this.m_btnTest.TabIndex = 3;
			this.m_btnTest.Text = "test";
			this.m_btnTest.Click += new System.EventHandler(this.m_btnTest_Click);
			// 
			// m_txtRes
			// 
			this.m_txtRes.Location = new System.Drawing.Point(90, 24);
			this.m_txtRes.Name = "m_txtRes";
			this.m_txtRes.Size = new System.Drawing.Size(114, 20);
			this.m_txtRes.TabIndex = 2;
			this.m_txtRes.Text = "text";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.m_txtRes);
			this.groupBox1.Controls.Add(this.m_btnTest);
			this.groupBox1.Location = new System.Drawing.Point(408, 372);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(210, 54);
			this.groupBox1.TabIndex = 4;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "TextBox - test";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.m_btnExampleData2);
			this.groupBox2.Controls.Add(this.m_btnExampleData);
			this.groupBox2.Controls.Add(this.m_btnSysConData);
			this.groupBox2.Location = new System.Drawing.Point(12, 372);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(384, 54);
			this.groupBox2.TabIndex = 5;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Diff Daten fr den Grid";
			// 
			// m_btnExampleData2
			// 
			this.m_btnExampleData2.Location = new System.Drawing.Point(240, 24);
			this.m_btnExampleData2.Name = "m_btnExampleData2";
			this.m_btnExampleData2.Size = new System.Drawing.Size(104, 24);
			this.m_btnExampleData2.TabIndex = 6;
			this.m_btnExampleData2.Text = "Dynamic Property";
			this.m_btnExampleData2.Click += new System.EventHandler(this.m_btnExampleData2_Click);
			// 
			// m_btnExampleData
			// 
			this.m_btnExampleData.Location = new System.Drawing.Point(126, 24);
			this.m_btnExampleData.Name = "m_btnExampleData";
			this.m_btnExampleData.Size = new System.Drawing.Size(104, 24);
			this.m_btnExampleData.TabIndex = 5;
			this.m_btnExampleData.Text = "Beispiel - Daten";
			this.m_btnExampleData.Click += new System.EventHandler(this.m_btnExampleData_Click);
			// 
			// m_btnSysConData
			// 
			this.m_btnSysConData.Location = new System.Drawing.Point(12, 24);
			this.m_btnSysConData.Name = "m_btnSysConData";
			this.m_btnSysConData.Size = new System.Drawing.Size(96, 24);
			this.m_btnSysConData.TabIndex = 4;
			this.m_btnSysConData.Text = "SysCon - Daten";
			this.m_btnSysConData.Click += new System.EventHandler(this.m_btnSysConData_Click);

			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(628, 435);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Name = "PropertyGrid";
			this.Text = "PropertyGrid";
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#endregion


		#region Controls handles
		/// <summary>
		/// Controls handles test
		/// </summary>
		/// 

		private void m_btnTest_Click(object sender, System.EventArgs e)
		{
			this.m_txtRes.Text = "priwet idiotam"; 

			string strTmp = "";
			ListAllValuesFromGrid(ref strTmp, "");
		}

		private void m_btnSysConData_Click(object sender, System.EventArgs e)
		{
			InitGridWithSysConData();
			m_propertyGridEigenschaften.Refresh(); 
		}

		private void m_btnExampleData_Click(object sender, System.EventArgs e)
		{
			InitGridWithExampleData();
			m_propertyGridEigenschaften.Refresh();
		}

		private void m_btnExampleData2_Click(object sender, System.EventArgs e)
		{
			InitGridWithExampleData2();
			m_propertyGridEigenschaften.Refresh();
		}

		// fr den Fall m_btnExampleData2 wichtig!
		private void propertyGrid1_PropertyValueChanged(
										object s, PropertyValueChangedEventArgs e)
		{
			m_propertyGridEigenschaften.Refresh();
		}

		#endregion


		#region Hilfsfunktionen

		private void InitGridWithSysConData()
		{
			AppSettings appset = new AppSettings();
			this.m_propertyGridEigenschaften.SelectedObject = appset;
		}

		private void InitGridWithExampleData()
		{
			PropGridData objExampleData = new PropGridData();
			this.m_propertyGridEigenschaften.SelectedObject = objExampleData;
		}

		private void InitGridWithExampleData2()
		{
			DynamicProperty objExampleData2 = new DynamicProperty();
			this.m_propertyGridEigenschaften.SelectedObject = objExampleData2;
		}

		private void ListAllValuesFromGrid(ref string strRes, string strPropName)
		{
			// 
			Type propGridType = m_propertyGridEigenschaften.GetType(); 

			//das interne GridControl im PropertyGrid holen 
			FieldInfo fi = propGridType.GetField( 
				"gridView", 
				BindingFlags.NonPublic | BindingFlags.Instance); 
			object gridView = fi.GetValue(m_propertyGridEigenschaften); 

			//Zugriff auf die interne GridEntryCollection 
			Type gridViewType = gridView.GetType(); 
			FieldInfo fi2 = gridViewType.GetField( 
				"allGridEntries", 
				BindingFlags.NonPublic | BindingFlags.Instance); 
			object allGridEntries = fi2.GetValue(gridView); 

			//ber jedes System.Windows.Forms.GridItem in
			//der GridEntryCollection iterieren
			foreach (object o in (IEnumerable) allGridEntries)
			{
				//Das sind unsere "Kategorien"
				GridItem gi = (GridItem) o;

				//Das sind einzelnen Items
				foreach (GridItem g in gi.GridItems)
				{
					Debug.WriteLine(g.Label + ": " + g.Value);

					if (g.Label == strPropName)
					{
						strRes = (string)g.Value;
					}

					//hat das Item hat noch weitere Untereintrge?
					if(g.Expandable)
					{
						Debug.Indent();
						foreach(GridItem g2 in g.GridItems)
						{
							Debug.WriteLine(g2.Label + ": " + g2.Value);
						}
						Debug.Unindent();
					}
					Debug.WriteLine("");
				}
			}
		}

		#endregion

		#region Get / Set

		public string BufRepSize
		{
			get
			{
				ListAllValuesFromGrid(ref m_strBufRep, "Buffered Report");
				return m_strBufRep;
			}

			set
			{
				m_strBufRep = value;
			}
		}

		#endregion

	}
}
